/**
  * Konsolen-Klasse zur Hilfsklasse GraphInit zeigt deren Mglichkeiten
  *
  * @author Michael Ziemke, Koeln 
  * @version 2.0 vom 24.06.2017
  */

public class ConGraphInit {
  // GraphInit-Objekt aus IniText-Datei erzeugen:
  // rel. Verzeichnis und Dateiname der einzulesenden TXT-Datei mit Graphendaten:
  private static GraphInit test = new GraphInit(".\\txt", "deutschland.txt");
  
  // bergebene IniText-Daten zur Erzeugung zweier weiterer GraphInit-Objekte:
  private static String[] demo1= {
    "1,S1,3,1", "2,S2,1,0", "3,S3,0,2",
    "-", "Symmetrie = 1", "-",
    "1,2,1", "1,3,16", "2,3,12"
    };
  private static String[] demo2 = {
    "1,S1,3,1", "2,S2,1,0", "3,S3,0,2",
    "-", "Symmetrie = 0", "-",
    "1,2,13", "1,3,16", "2,1,1", "2,3,2", "3,1,8", "3,2,12"
    };
  // GraphInit-Objekt aus bergebenen IniText-Daten erzeugen:
  private static GraphInit test1 = new GraphInit(demo1, "Demo1");
  private static GraphInit test2 = new GraphInit(demo2, "Demo2");
  
  /**
   * erzeugt drei GraphInit-Objekte und zeigt auf der Konsole als Reprsentanzen
   * deren Adjazenz-Matrix und deren Graph-Objekt-Bestandteile (Knoten und Kanten)
   */
  public static void main(String[] args) {
    System.out.println("Konsolen-Programm zur Klasse GraphInit zeigt Daten dreier Graphen");
    System.out.println("(c) Juni 2017  Michael Ziemke, Koeln");
    zeigeMatrix(test, true);   // zur Kontrolle; mit Knotennamen
    zeigeKnotenKoord (test);
    zeigeEinenKnoten(test, 7);
    zeigeMatrix(test1, false);   // zur Kontrolle; ohne Knotennamen
    zeigeMatrix(test2, true);   // zur Kontrolle; mit Knotennamen
    zeigeGraph (test, true);   // mit Koordinaten der XVertex-Objekte
  } // end of main
  
  /**
   * zeigt auf der Konsole als Reprsentanz
   * die Daten der Adjazenz-Matrix des Graph-Objekts (Gewichte)
   */
  public static void zeigeMatrix(GraphInit pWhich, boolean pMitKnoten) {
    String lTemp, lHead;
    int[][] lMatrix = pWhich.gibMatrix();
    int lMax = pWhich.gibDimension();
    String lKnotenFolge = pWhich.gibKnotenFolge();
    String[] lKnotenFeld = lKnotenFolge.split(",");
    lHead = "     |";
    for (int i=1 ; i<lKnotenFeld.length ; i++) {
      // lKnotenFeld[i] = lKnotenFeld[i].substring(0,4);
      lHead += " " + (lKnotenFeld[i] + "   ").substring(0,3) + " |";
    }
    //String lHead = "     |" + lKnotenFolge.replaceAll(",","  | ").substring(3) + "  |";
    System.out.println("\nAdjazenz-Matrix zu " + pWhich.gibName() + ":");  
    if (pMitKnoten)
      System.out.println(lHead);  
    for (int i=1 ; i<lMax ; i++) {
      if (pMitKnoten)
        System.out.print ((" "+lKnotenFeld[i]+"   ").substring(0,4) + " |");
      for (int j=1 ; j<lMax ; j++) {
        lTemp = "      ";
        if (lMatrix[i][j] != -1) 
          lTemp = " "+lMatrix[i][j] + "    ";
        System.out.print (lTemp.substring(0,4) + " |");
      }
      System.out.println();  
    } // end of for
  }
  
  /**
   * zeigt auf der Konsole als Daten-Reprsentanz
   * die graphischen Koordinaten aller Knoten
   */
  public static void zeigeKnotenKoord(GraphInit pWhich)
  {
    String[] lTemp = pWhich.gibKnotenKoordAlsStrings(0);  // 0: alle, sonst Nummer!
    System.out.println("\nGraphische Koordinaten aller Knoten zu " + pWhich.gibName() + ":");  
    for (int i=1 ; i<lTemp.length ; i++ ) {
      System.out.println(lTemp[i]);
    } // end of for
  }
  
  /**
   * holt und wandelt und zeigt die beiden Koordinaten eines Knotens als int-Werte
   */    
  public static void zeigeEinenKnoten(GraphInit pWhich, int pNummer)
  {
    String[] lTemp = pWhich.gibKnotenKoord(pNummer)[0].split(",");  // Feld der KnotenKoord
    String[] lKnoten = pWhich.gibKnotenFolge().split(",");  // Feld der KnotenNamen
//System.out.println("DEBUG lTemp[0]=" + lTemp[0]);    
    System.out.println("\nGraphische Koordinaten des Knotens #" + pNummer+ " zu " + pWhich.gibName() + ":");  
    //System.out.println("Knoten #" + pNummer + " hat x=" + Integer.parseInt(lTemp[0]) + " und y=" + Integer.parseInt(lTemp[1])); 
    System.out.println("Knoten #" + pNummer + " mit Name " + lKnoten[pNummer] + " hat x=" + lTemp[0] + " und y=" + lTemp[1]); 
  }  
  
  /**
   * zeigt auf der Konsole als Reprsentanz
   * die Bestandteile des Graph-Objekts (Daten zu Knoten und Kanten)
   */
  public static void zeigeGraph(GraphInit pWhich, boolean pMitXVertex)
  {
    System.out.println("\nDaten des Graph-Objekts von " + pWhich.gibName() + ":");
    String[] lTemp = pWhich.gibGraphAlsStrings(pMitXVertex);
    int lMax = lTemp.length;
    for (int i=0 ; i<lMax ; i++) {
      System.out.println(lTemp[i]);
    } // end of for
  }  
} // end of class ConGraphInit
