/**
 * <p>
 * Materialien zu den zentralen NRW-Abiturpruefungen im Fach Informatik ab 2018
 * </p>
 * <p>
 * Klasse XVertex spezialisiert die Klasse Vertex
 * </p>
 * <p>
 * Die Klasse XVertex stellt einen einzelnen Knoten eines Graphen dar. Jedes Objekt 
 * dieser Klasse verfuegt ueber eine im Graphen eindeutige ID als String und kann diese 
 * ID zurueckliefern. Darueber hinaus kann eine Markierung gesetzt und abgefragt werden.
*  Zustzlich sind hier x- und y-Koordinate fr die GUI-Darstellung implementiert.
 * </p>
 * 
 * @author Michael Ziemke, Koeln und Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule
 * @version Juli 2017 und Oktober 2015
 */
public class XVertex extends Vertex{
  //Einmalige ID des Knotens und Markierung
  private String id;
  private boolean mark;
  private int x, y;
  
  /**
  * Ein neues Objekt vom Typ XVertex wird erstellt mit Koordinaten zur GUI-Darstellung.
  */
  public XVertex(String pID, int pX, int pY){
    super (pID);  // Konstruktor der Oberklasse Vertex
    this.x = pX;
    this.y = pY;
  }
  
  /**
  * Die Anfrage liefert die GUI-x-Koordinate des Knotens als int.
  */
  public int getX(){
    return this.x;
  }
  
  /**
  * Die Anfrage liefert die GUI-y-Koordinate des Knotens als int.
  */
  public int getY(){
    return this.y;
  }
  
}
